#ifndef INC_S_H
#define INC_S_H

#pragma warning(disable:4244;disable:4018;disable:4305)

#include <assert.h>
#include <math.h>
#include <vector>
using namespace std;

extern double score, music_time;
typedef unsigned char uint8;

#include "glfw.h"

#include "vec.h"
#include "util.h"

#include "object.h"
#include "world.h"
#include "texture.h"
#include "ai.h"
#include "map.h"
#include "text.h"
#include "model.h"

#define PI   3.1415926f

#define clamp(x,a,b) \
  ((x) < (a) ? (a) : (x) > (b) ? (b) : (x))

extern void init_artwork(void);
extern Mesh *get_mesh(char *s);

#define ACOUNT(x)   (sizeof(x) / sizeof(x[0]))


#endif
