#include "s.h"

GLuint font_tex;

struct Character
{
   float s0,t0,s1,t1;
};
Character chardata[256];

void textInit(void)
{
   char *font_data = " 0123456789."
      "ABCDEFGHI=KLMNOP:RSTUVW-Y,"
      "abcdefghijklmnopqrstuvwxyz";
   font_tex = textureAlpha("font1.png");
   textureClamp(font_tex);
   for (int i=0; font_data[i]; ++i) {
      char c = font_data[i];
      Character *z = &chardata[c];
      z->s0 = (i+0.5/16) / 64.0;
      z->s1 = (i+1 - 0.5/16)/64.0;
      z->t0 = 0;
      z->t1 = 1;
   }
}

void print(float scale, float x, float y, char *s, ...)
{
   char buffer[999];
   va_list v;
   va_start(v,s);
   vsprintf(buffer, s, v);
   s = buffer;

   glBindTexture(GL_TEXTURE_2D, font_tex);
   glEnable(GL_TEXTURE_2D);
   while (*s) {
      char c = *s++;
      Character *z = &chardata[c];
      rect2dtex(z->s0, z->t0, z->s1, z->t1, x,y,16*scale,-32*scale);
      x += 16*scale;
   }

   va_end(v);
}

void print2(float scale, float x, float y, char *s, ...)
{
   char buffer[999];
   va_list v;
   va_start(v,s);
   vsprintf(buffer, s, v);
   s = buffer;

   glBindTexture(GL_TEXTURE_2D, font_tex);
   glEnable(GL_TEXTURE_2D);
   while (*s) {
      char c = *s++;
      Character *z = &chardata[c];
      rect2dtex_fat(z->s0, z->t0, z->s1, z->t1, x,y,16*scale,-32*scale);
      x += 16*scale;
   }

   va_end(v);
}
